unit Sdimain;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, AMMemo;

type
  TSDIAppForm = class(TForm)
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    OpenItem: TMenuItem;
    SaveItem: TMenuItem;
    ExitItem: TMenuItem;
    N1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Help1: TMenuItem;
    About1: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    StatusBar: TStatusBar;
    AMMemo1: TAMMemo;
    SpeedButton1: TSpeedButton;
    Edit1: TMenuItem;
    Find1: TMenuItem;
    Findnext1: TMenuItem;
    N2: TMenuItem;
    Replace1: TMenuItem;
    N3: TMenuItem;
    Undo1: TMenuItem;
    SpeedButton2: TSpeedButton;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    Edit3: TEdit;
    Edit4: TEdit;
    Label2: TLabel;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    Label3: TLabel;
    SpeedButton3: TSpeedButton;
    N4: TMenuItem;
    Settabstops1: TMenuItem;
    procedure ShowHint(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure OpenItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure AMMemo1CaretPosChange(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure Findnext1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure Settabstops1Click(Sender: TObject);
    procedure AMMemo1TabStopsChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SDIAppForm: TSDIAppForm;

implementation

uses SysUtils, About, tabset;

{$R *.DFM}

procedure TSDIAppForm.ShowHint(Sender: TObject);
begin
  StatusBar.Panels[3].Text := Application.Hint;
end;

procedure TSDIAppForm.ExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TSDIAppForm.OpenItemClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    AMMemo1.Lines.LoadFromFile(OpenDialog.FileName);
end;

procedure TSDIAppForm.SaveItemClick(Sender: TObject);
begin
  SaveDialog.Execute;
end;

procedure TSDIAppForm.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TSDIAppForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
  Edit3.Text := IntToStr(AMMemo1.LeftMargin);
  Edit4.Text := IntToStr(AMMemo1.RightMargin);
end;

procedure TSDIAppForm.Undo1Click(Sender: TObject);
begin
  try
    AMMemo1.Undo;
  except
    ShowMessage('Cannot undo last action...');
  end;
end;

procedure TSDIAppForm.AMMemo1CaretPosChange(Sender: TObject);
begin
  with StatusBar do
  begin
    Panels[0].Text := 'Line '+IntToStr(AMMemo1.LinePos)+ ' of '+IntToStr(AMMemo1.Lines.Count);
    Panels[1].Text := 'Pos '+IntToStr(AMMemo1.CharPos);
    Panels[2].Text := 'Lenght '+IntToStr(AMMemo1.LineLength);
  end;
end;

procedure TSDIAppForm.Find1Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TSDIAppForm.FindDialog1Find(Sender: TObject);
begin
  with AMMemo1 do
  begin
    if FindDialog1.Options*[frMatchCase] = [frMatchCase] then CaseSensitive := true else CaseSensitive := false;

    FindText := FindDialog1.FindText;
    try
      Find;
    except
      ShowMessage('No more "'+AMMemo1.FindText+'" found!');
    end;
  end;
  FindDialog1.CloseDialog;
end;

procedure TSDIAppForm.Findnext1Click(Sender: TObject);
begin
  try
    AMMemo1.Find;
  except
    ShowMessage('No more "'+AMMemo1.FindText+'" found!');
  end;
end;

procedure TSDIAppForm.Replace1Click(Sender: TObject);
begin
  ReplaceDialog1.FindText := AMMemo1.FindText;
  ReplaceDialog1.ReplaceText := AMMemo1.ReplaceText;
  ReplaceDialog1.Execute;
end;

procedure TSDIAppForm.ReplaceDialog1Replace(Sender: TObject);
begin
  with AMMemo1 do
  begin
    FindText := ReplaceDialog1.FindText;
    ReplaceText := ReplaceDialog1.ReplaceText;
    if ReplaceDialog1.Options*[frMatchCase] = [frMatchCase] then CaseSensitive := true else CaseSensitive := false;
    if ReplaceDialog1.Options*[frReplaceAll] = [frReplaceAll] then
    begin
      try
        Find;
        ReplaceAll;
      except
        ShowMessage('All replaced...');
      end;
    end
    else
      Replace;
  end;
end;

procedure TSDIAppForm.Edit3Change(Sender: TObject);
begin
  AMMemo1.LeftMargin := StrToInt(Edit3.Text);
end;

procedure TSDIAppForm.Edit4Change(Sender: TObject);
begin
  AMMemo1.RightMargin := StrToInt(Edit4.Text);
end;

procedure TSDIAppForm.ReplaceDialog1Find(Sender: TObject);
begin
  with AMMemo1 do
  begin
    if ReplaceDialog1.Options*[frMatchCase] = [frMatchCase] then CaseSensitive := true else CaseSensitive := false;

    FindText := ReplaceDialog1.FindText;
    try
      Find;
    except
      ShowMessage('No more "'+AMMemo1.FindText+'" found to replace with "'+AMMemo1.ReplaceText+'"');
    end;
  end;
end;

procedure TSDIAppForm.Settabstops1Click(Sender: TObject);
var
  TabSetForm: TTabsForm;
begin
  TabSetForm := TTabsForm.Create(Application);
  TabSetForm.ShowModal;
end;

procedure TSDIAppForm.AMMemo1TabStopsChange(Sender: TObject);
begin
  ShowMessage('The tabstops has been changed...');
end;

end.
 
